unit Temperature;

interface

uses
  {Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;}
  Classes;

type

  TTemperature = class(TComponent)

  private
    {Private declarations}
    dF : Extended;
    dC : Extended;
    dK : Extended;
    procedure SetFDegree( dFD : Extended);
    procedure SetCDegree( dCD : Extended);
    procedure SetKDegree( dKD : Extended);

  protected
    { Protected declarations }


  public
    { Public declarations }
    constructor Create(AOwner:TComponent);override;

  published
    { Published declarations }
    property F: Extended read dF write SetFDegree;
    property C: Extended read dC write SetCDegree;
    property K: Extended read dK write SetKDegree;

  end;

{procedure Register;}

implementation

{procedure Register;
begin
  RegisterComponents('Samples', [TTemperature]);
end;}

  constructor TTemperature.Create(AOwner:TComponent);
  begin
    inherited Create(AOwner);
    SetCDegree(0);
  end;

  procedure TTemperature.SetFDegree;
  begin
    dF := dFD;
    dC := (dFD - 32) * (5.0/9.0);
    dK := dC + 273.15;
  end;

  procedure TTemperature.SetCDegree;
  begin
    dC := dCD;
    dF := dC * (9.0/5.0) + 32;
    dK := dC + 273.15;
  end;

  procedure TTemperature.SetKDegree;
  begin
    dK := dKD;
    dC := dKD - 273.15;
    dF := dC * (9.0/5.0) + 32;
  end;

end.
